 /* chat v1.3
 * 
 */

#define CONSOLE "/dev/console"

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <termio.h>
#include <signal.h>
#include <utmp.h>
#include "citadel.h"

int console;
char online;
char temp[20];

long lseek();
long atol();


int (*slamcarrier())() {
	if (online==1) write(console,"*off line*  Press ctrl-c to exit\r\n",34);
	unlink("/tmp/chat.online");
	exit(0);
}

main(argc,argv)
int argc;
char *argv[];
{
	int a,b,c,d,e;
	int file;
	char aaa[100];
	struct termio term,saveio;
	FILE *fp,*arc;

	chdir(BBSDIR);

	if (!strncmp(ttyname(0),CONSOLE,strlen(CONSOLE))) {
		conchat(argc,argv);
		exit(0);
		}	

	if (isclog()==0) {
		printf("No one else is online.\n");
		exit(0);
		}

	online=0;
	ioctl(0,TCGETA,&saveio);
	ioctl(0,TCGETA,&term);

	term.c_iflag=3366;
	term.c_oflag=6149;
	term.c_lflag=59;
	term.c_line=0;
	term.c_cc[0]=127;
	term.c_cc[1]=28;
	term.c_cc[2]=8;
	term.c_cc[3]=24;
	term.c_cc[4]=4;
	term.c_cc[5]=255;
	term.c_cc[6]=0;
	term.c_cc[7]=0;
	term.c_lflag=0;
	term.c_iflag=ISTRIP;
	ioctl(0,TCSETA,&term);

	fp=fopen("/tmp/chat.name","w");
	fprintf(fp,"%s\n",ttyname(0));
	fclose(fp);

	console=open(CONSOLE,O_WRONLY);
	if (console<0) {
		fprintf(stderr,"Can't access %s\r\n",CONSOLE);
		goto END;
		}

	fprintf(stderr,"Paging %s...\r\n",CONSOLE);
	for (a=0; a<4; ++a) {
		b=7;
		write(console,&b,1);
		write(1,&b,1);
		sleep(1);
		}
	printf("Chat mode - press ctrl-c to exit if\r\n");
	printf("no one answers in a minute or so...\r\n");

A:	b=0; read(0,&b,1);			/* read a character */
	if (b==3) {
		printf("Exiting chat mode\r\n");
		goto END;
		}
	if (online==1) {
		c=10;
		write(console,&b,1); write(1,&b,1);
		putc(b,arc); fflush(arc);
		if (b==13) { write(console,&c,1); write(1,&c,1); }
		goto A;
		}
	/* not online, check for flag file */
	file=open("/tmp/chat.online",O_RDONLY); close(file);
	if (file>(-1)) {
		online=1;
		unlink("/tmp/chat.online");
		arc=fopen("/tmp/chat.fifo","w+");
		sprintf(aaa,"Online with user: %s\r\n",argv[1]);
		fprintf(arc,"%s",aaa);
		fflush(arc);
		write(console,aaa,strlen(aaa)); aaa[0]=0;
		signal(SIGHUP,(*slamcarrier));
		write(console,&b,1); write(2,&b,1);
		putc(b,arc); fflush(fp);
		}
	goto A;

END:	unlink("/tmp/chat.online"); unlink("/tmp/chat.name");
	if (online==1)
		write(console,"*off line*  Press ctrl-c to exit\r\n",34);
	close(console);
	ioctl(0,TCSETA,&saveio);
	unlink("/tmp/chat.fifo");
	exit(0);
}

conchat(argc,argv)
int argc;
char *argv[];
{
	int a,b,c,d,e;
	int console,file,file2;
	char online;
	char aaa[100],bbb[100];
	struct termio term,saveio;
	FILE *arc;

	online=0;
	ioctl(0,TCGETA,&saveio);
	ioctl(0,TCGETA,&term);

	term.c_iflag=3366;
	term.c_oflag=6149;
	term.c_lflag=59;
	term.c_line=0;
	term.c_cc[0]=127;
	term.c_cc[1]=28;
	term.c_cc[2]=8;
	term.c_cc[3]=24;
	term.c_cc[4]=4;
	term.c_cc[5]=255;
	term.c_cc[6]=0;
	term.c_cc[7]=0;
	term.c_lflag=0;
	term.c_iflag=ISTRIP;
	ioctl(0,TCSETA,&term);

	file=open("/tmp/chat.name",O_RDONLY);
	if (file<0) {
 		printf("No one has requested a chat.\r\n");
		goto END;
		}

system(
"/etc/mknod /tmp/chat.fifo p; nohup aidepost </tmp/chat.fifo 2>/dev/null &");
	if (fork()==0) aidepost();
	read(file,bbb,30); close(file); unlink("/tmp/chat.name");
	for (a=0; a<strlen(bbb); ++a) if (bbb[a]==10) bbb[a]=0;
	printf("Connected to: %s\r\n",bbb);
	file=open(bbb,O_WRONLY);
	if (file<0) {
		printf("Can't open %s\r\n",bbb);
		goto END;
		}
	file2=creat("/tmp/chat.online",0666); close(file2);
	sprintf(aaa,"\n*answer* - Online with: %s\r\n",argv[1]);
	write(file,aaa,strlen(aaa));

	arc=fopen("/tmp/chat.fifo","w+");
	fprintf(arc,"%s",aaa); aaa[0]=0;
	fflush(arc);
	unlink("nohup.out");

A:	b=0; read(0,&b,1);
	if (b==3) {
		write(file,"*off line*  Press ctrl-c to exit\r\n",34);
		write(file,"Press ctrl-c to return to the BBS.\r\n",36);
		close(file);
		fprintf(arc,"\n*out*\n");
		fclose(arc);
		goto END;
		}
	c=10;
	write(file,&b,1); write(1,&b,1);
	putc(b,arc);
	if (b==13) {
		write(file,&c,1);
		write(1,&c,1);
		}
	fflush(arc);
	goto A;

END:
	ioctl(0,TCSETA,&saveio);
	exit(0);
}

isclog() {
	struct utmp utmp;
	int file,a;
	a=0;
	file=open("/etc/utmp",O_RDONLY);
	while ((read(file,&utmp,sizeof(struct utmp)))) {
	 if ((utmp.ut_name[0]!=0)&&(!strcmp(utmp.ut_line,"console"))) a=1;
	}
	close(file);
	return(a);
}

strucmp(st1,st2)
char st1[],st2[];
{
	int a;
	char aaa[100],bbb[100];
	for (a=0; a<=strlen(st1); ++a) aaa[a]=tolower(st1[a]);
	for (a=0; a<=strlen(st2); ++a) bbb[a]=tolower(st2[a]);
	a=strcmp(aaa,bbb);
	return(a);
}

send_message(filename,retbuf)	/* send a message to the master file */
char filename[];		/* tempfilename of proper message */
struct smreturn *retbuf;	/* return information */
{

int file,a,b,c,d,e,file2;
long aa,bb,cc,dd,ee,templen,hibytes,origpos;
char aaa[100],mid[30];
struct msgmain msgmain;


	file=open("/usr/bbs/MMstructure",O_RDWR);
	if (file<0) exit(13);
PWMINS:
	a=read(file,&msgmain,sizeof(struct msgmain));
	if (a<1) exit(14);
	if (msgmain.MMflags & MM_BUSY) {
					 lseek(file,0L,0); goto PWMINS; }

	lseek(file,0L,0);
	msgmain.MMflags=(msgmain.MMflags|MM_BUSY);
	a=write(file,&msgmain,sizeof(struct msgmain)); if (a<1) exit(16);
	close(file);
	origpos=msgmain.MMcurpos;
	++msgmain.MMhighest;
	sprintf(mid,"I%ld",msgmain.MMhighest);
/* measure the message */
file=open(filename,O_RDONLY); if (file<0) sprintf(stderr,"aidepost: error\n");
templen=lseek(file,0L,2);
close(file);
templen=templen+(long)strlen(mid);
++templen;

/* check for FF bytes */
hibytes=0L;
file=open("/usr/bbs/msgmain",O_RDWR);
if (file<0) fprintf(stderr,"aidepost: can't open msgmain\n");
bb=lseek(file,msgmain.MMcurpos,0);

cc=lseek(file,0L,1);
for (bb=0L; bb<templen; ++bb) {
	if (cc>=MM_FILELEN) cc=lseek(file,0L,0);
	c=0; read(file,&c,1); ++cc;
	if (c>127) ++hibytes;		/* bump count if hi bit set */
	}

msgmain.MMlowest=msgmain.MMlowest+hibytes;

cc=lseek(file,msgmain.MMcurpos,0);

file2=open(filename,O_RDONLY); if (file2<0) exit(19);
cc=lseek(file,0L,1);
read(file2,&b,2);
write(file,&b,2);
read(file2,&b,1);
write(file,&b,1);
write(file,mid,(strlen(mid)+1));
for (bb=0L; bb<templen; ++bb) {
	if (((long)cc)>=((long)MM_FILELEN)) cc=lseek(file,0L,0);
	read(file2,&b,1); 
	write(file,&b,1); ++cc;
	}
msgmain.MMcurpos=lseek(file,0L,1);
close(file2);	/* done with temp file */
close(file);	/* done with master file */


/* now update the message structure */

msgmain.MMflags=msgmain.MMflags & ~MM_BUSY;

file=open("/usr/bbs/MMstructure",O_RDWR); if (file<0) printf("20!!!\n");
a=write(file,&msgmain,sizeof(struct msgmain)); if (a<1) printf("21!!!\n");
close(file);
retbuf->smnumber=msgmain.MMhighest;
retbuf->smpos=origpos;



return(0);

}

make_message(filename)
char filename[];	/* temporary file name */
{ 
	FILE *fp,*arc;
	int a,b,c,old;
	long aa,bb,cc,beg,now;
	char aaa[100],bbb[100]; 
	time(&now);
	fp=fopen(filename,"wb"); if (fp==NULL) exit(22);
	arc=fopen("/tmp/chat.fifo","r");
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(1,fp);
	fprintf(fp,"T%ld",now); putc(0,fp);
	fprintf(fp,"AChat Archive"); putc(0,fp);
	fprintf(fp,"OAide"); putc(0,fp);
	fprintf(fp,"N%s",NODENAME); putc(0,fp);
	putc('M',fp);
	while ((a=getc(arc))>0) {
		putc(a,fp);
		}
MEFIN:	putc(0,fp);
	fclose(fp);
	fclose(arc);
	unlink("/tmp/chat.fifo");
	return(0);

}

aidepost() {
	int file,a,b;
	long aa;
	char aaa[100];
	struct smreturn mybuffer;
	struct quickroom quickroom;
	struct fullroom fullroom;

	make_message(temp);
	send_message(temp,&mybuffer);
	unlink(temp);

	file=open("./quickroom",O_RDWR);
	b=2;
	lseek(file,(long)(b*sizeof(struct quickroom)),0);
	read(file,&quickroom,sizeof(struct quickroom));
	quickroom.QRhighest=mybuffer.smnumber;
	lseek(file,(long)(b*sizeof(struct quickroom)),0);
	write(file,&quickroom,sizeof(struct quickroom));
	close(file);

	sprintf(aaa,"./rooms/fullrm%d",b);
	file=open(aaa,O_RDWR);
	read(file,&fullroom,sizeof(struct fullroom));
	for (a=0; a<(MSGSPERRM-1); ++a) {
		fullroom.FRnum[a]=fullroom.FRnum[a+1];
		fullroom.FRpos[a]=fullroom.FRpos[a+1];
		}
	fullroom.FRnum[MSGSPERRM-1]=mybuffer.smnumber;
	fullroom.FRpos[MSGSPERRM-1]=mybuffer.smpos;
	lseek(file,0L,0);
	write(file,&fullroom,sizeof(struct fullroom));
	close(file);
	exit(0);
}
