#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#include <termio.h>
#include "citadel.h"

#define IFEXPERT if (usersupp.flags&US_EXPERT)
#define IFNEXPERT if ((usersupp.flags&US_EXPERT)==0)
#define IFUPASS if (upass!=0)
#define IFNUPASS if (upass==0)
#define IFAIDE if (usersupp.flags&US_AIDE)
#define IFNAIDE if ((usersupp.flags&US_AIDE)==0)
long atol();
long lseek();

char *months[]={"Jan","Feb","Mar","Apr","May","Jun",
		"Jul","Aug","Sep","Oct","Nov","Dec"};

main(argc,argv)
int argc;
char *argv[]; {
	if (argc==1) msgform(0L,"",0);
	if (argc==2) msgform(0L,argv[1],0);
	if (argc==3) msgform(atol(argv[2]),argv[1],0);
	if (argc==4) msgform(atol(argv[2]),argv[1],1);
	exit(0);
	}

msgform(spos,msgfile,mflag)
long spos;
char msgfile[];
int mflag;
	{
	struct tm *tm;
	int a,b,c,d,e,real,old,mtype,aflag,width;
	char aaa[100],bbb[100],ttm[3],ap;
	char A[30],R[30],T[30],N[30],O[30];
	char flnm[20];
	FILE *fp;
	long now;

	width=80;

	strcpy(flnm,msgfile);
	if (!strcmp(flnm,"-m")) {
		strcpy(flnm,"/usr/bbs/msgmain");
		mflag=1;
		}
	if (flnm[0]==0) fp=stdin;
		else fp=fopen(flnm,"rb");
	if (fp==NULL) return(1);
	fseek(fp,spos,0);
LOOP:	strcpy(aaa,""); old=255;
	c=1; /* current column pos */
	do {
		e=getc(fp);
		if (e<0) {
			fclose(fp);
			return(0);
			}
		} while(e!=255);
	if (e!=255) {
		printf("===> CANNOT LOCATE MESSAGE / pos=%ld\n",spos);
		goto END; }
	mtype=getc(fp); aflag=getc(fp);
	goto BONCLR;

AA:	if ((mflag==1)&&(strcmp(O,"Mail"))) {
		do { a=getc(fp);
			} while(a!=0);
		goto LOOP;
		}
	printf("\n   ");
	if (mtype==MES_ANON) printf("****\n");
	if (mtype==MES_AN2) printf("<anonymous> ");
	if (T[0]!=0) printf("%s ",T);
	if (A[0]!=0) printf("from %s ",A);
	if (R[0]!=0) printf("to %s ",R);
	if (O[0]!=0) printf("in %s> ",O);
	if (N[0]!=0) printf("@ %s ",N);
	printf("\n");
AAA:	if (aflag==1) goto AFLAG;
	old=real; a=getc(fp); real=a;
	if (a==0) goto END;
	if (a<0) goto END;
	
	if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) a=32;
	if ( ((old==13)||(old==10)) && ((real==32)||(real==13)||(real==10))) {
						printf("\n"); c=1; }

	if (a!=32) {
	if ( ((strlen(aaa)+c)>(width-4)) && (strlen(aaa)>(width-4)) )
		{ printf("\n%s",aaa); c=strlen(aaa); aaa[0]=0; }
	 b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
	if (a==32) { 	if ((strlen(aaa)+c)>(width-5)) { 
							printf("\n");
							c=1;
							}
			printf("%s ",aaa); ++c; c=c+strlen(aaa);
			strcpy(aaa,""); goto AAA; }
	if ((a==13)||(a==10)) {
				printf("%s\n",aaa); c=1;
				strcpy(aaa,""); goto AAA; }
	goto AAA;

AFLAG:	a=getc(fp); if (a==0) goto END;
	putc(a,stdout); if (a==13) putc(10,stdout);
	goto AFLAG;

END:
	printf("\n");
	goto LOOP;

BONCLR:	strcpy(A,""); strcpy(R,""); strcpy(T,""); strcpy(O,""); strcpy(N,"");
BONFGM:	b=getc(fp); if (b<0) goto END;
	if (b=='M') goto AA;
	fpgetfield(fp,bbb);
	if (b=='A') strcpy(A,bbb);
	if (b=='N') strcpy(N,bbb);
	if (b=='O') strcpy(O,bbb);
	if (b=='R') strcpy(R,bbb);

	if (b=='T') { now=atol(bbb);
		tm=(struct tm *)localtime(&now);
		sprintf(ttm,"%2d",tm->tm_min);
		if (ttm[0]==32) ttm[0]=48;
		ap='a'; if ((tm->tm_hour)>12) {
			tm->tm_hour=((tm->tm_hour)-12);
			ap='p';
			}
		sprintf(T,"%d-%s-%4d %d:%2s%cm ",
			tm->tm_mday,months[tm->tm_mon],
			(1900+tm->tm_year),
			tm->tm_hour,ttm,ap);
		}
	goto BONFGM;
}
fpgetfield(fp,string)
FILE *fp;
char string[];
{
int a,b;
strcpy(string,"");
a=0;
	do {
		b=getc(fp);
		if (b<1) { string[a]=0; return(0); }
		string[a]=b;
		++a;
		} while(b!=0);
}
